package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineSystemSetting struct {
	api.Api
}

// GetPage 获取挂单配置列表
// @Summary 获取挂单配置列表
// @Description 获取挂单配置列表
// @Tags 挂单配置
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineSystemSetting}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-system-setting [get]
// @Security Bearer
func (e LineSystemSetting) GetPage(c *gin.Context) {
	req := dto.LineSystemSettingGetPageReq{}
	s := service.LineSystemSetting{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineSystemSetting, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取挂单配置失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取挂单配置
// @Summary 获取挂单配置
// @Description 获取挂单配置
// @Tags 挂单配置
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineSystemSetting} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-system-setting/{id} [get]
// @Security Bearer
func (e LineSystemSetting) Get(c *gin.Context) {
	req := dto.LineSystemSettingGetReq{}
	s := service.LineSystemSetting{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineSystemSetting

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取挂单配置失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建挂单配置
// @Summary 创建挂单配置
// @Description 创建挂单配置
// @Tags 挂单配置
// @Accept application/json
// @Product application/json
// @Param data body dto.LineSystemSettingInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-system-setting [post]
// @Security Bearer
func (e LineSystemSetting) Insert(c *gin.Context) {
	req := dto.LineSystemSettingInsertReq{}
	s := service.LineSystemSetting{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建挂单配置失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改挂单配置
// @Summary 修改挂单配置
// @Description 修改挂单配置
// @Tags 挂单配置
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineSystemSettingUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-system-setting/{id} [put]
// @Security Bearer
func (e LineSystemSetting) Update(c *gin.Context) {
	req := dto.LineSystemSettingUpdateReq{}
	s := service.LineSystemSetting{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改挂单配置失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除挂单配置
// @Summary 删除挂单配置
// @Description 删除挂单配置
// @Tags 挂单配置
// @Param data body dto.LineSystemSettingDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-system-setting [delete]
// @Security Bearer
func (e LineSystemSetting) Delete(c *gin.Context) {
	s := service.LineSystemSetting{}
	req := dto.LineSystemSettingDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除挂单配置失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
